package eu.dnetlib.services.oai;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.domain.EntityScan;

import eu.dnetlib.common.app.AbstractDnetApp;
import eu.dnetlib.domain.oai.OaiConfiguration;
import eu.dnetlib.domain.oai.OaiMetadataFormat;
import eu.dnetlib.domain.oai.OaiRecord;
import eu.dnetlib.domain.oai.OaiSet;
import eu.dnetlib.domain.service.ServiceType;

@SpringBootApplication
@EntityScan(basePackageClasses = { OaiConfiguration.class, OaiSet.class, OaiMetadataFormat.class, OaiRecord.class })
public class OaiApplication extends AbstractDnetApp {

	public static void main(final String[] args) {
		SpringApplication.run(OaiApplication.class, args);
	}

	@Override
	protected ServiceType serviceType() {
		return ServiceType.oai_manager;
	}
}
