package eu.dnetlib.common.clients;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

import eu.dnetlib.domain.oai.OaiConfiguration;
import eu.dnetlib.domain.oai.OaiSet;

public class OaiManagerClient extends DnetServiceClient {

	public OaiConfiguration getOaiConfiguration() {
		return httpGet("/api/oai/conf", OaiConfiguration.class, Map.of());
	}

	public List<OaiSet> listSets() {
		return Arrays.asList(httpGet("/api/oai/sets", OaiSet[].class, Map.of()));
	}

	public void createOaiSet(final OaiSet oaiSet) {
		httpPostObject("/api/oai/sets", oaiSet, OaiSet[].class, Map.of());
	}

}
