package eu.dnetlib.common.mapping.xslt;

import java.util.Map;

import eu.dnetlib.common.clients.DnetServiceClientFactory;
import eu.dnetlib.common.clients.SimpleResourceClient;
import eu.dnetlib.common.mapping.RecordTransformer;
import eu.dnetlib.errors.TransformationException;

public class XsltTransformFactory {

	public static final String QNAME_BASE_URI = "http://eu/dnetlib/transform";

	private final DnetServiceClientFactory clientFactory;

	private final DnetXsltFunction[] xsltFunctions;

	public XsltTransformFactory(final DnetServiceClientFactory clientFactory, final DnetXsltFunction... xsltFunctions) {
		this.clientFactory = clientFactory;
		this.xsltFunctions = xsltFunctions;
	}

	public RecordTransformer<String, String> getTransformer(final String ruleId, final Map<String, Object> initialParams) throws TransformationException {
		try {
			final String xsltText = clientFactory.getClient(SimpleResourceClient.class).findResourceContent(ruleId, String.class);

			return XsltUtils.newTransformer(xsltText, initialParams, xsltFunctions);

		} catch (final Throwable e) {
			throw new TransformationException("error preparing xslt transfomer", e);
		}
	}

}
